Subject: Re: Bug#216768: apt: Confirmed under Lenny with several sources and pinning

From: Vincent Lefevre <[email-masked]>
Date: Mon, 2 Nov 2009 17:13:23 +0100

On 2009-11-02 16:40:00 +0100, David Kalnischkies wrote:
> The message says:
> "This should NOT be done unless you know exactly what you are doing!"

Well, this was "The following essential packages will be removed."
I found confusing.

> So it is already open to the fact that it is maybe wrong to consider
> the package essential and that it is really safe to remove it,
> but APT thinks it is a lot better to require the user to use special forces
> (long confirm message, holds on uninstalled packages) in some cases
> instead of let the user destroy his system in many more cases.
> I don't see why a user could think of a "inconsistent database" after
> read this message, maybe APT could say that this package
> was/is/will _maybe_ an essential, but i guess this would be even more
> confusing to a user. Suggestions for a better wording?
> (I can't think of a better one)

Perhaps it should be said that the essential state is package
specific and not version specific, because packages may depend
on them implicitly. Otherwise users who *think* they know, but
are not aware of such subtle points, could incorrectly assume
that removing the package is OK.

> The "real" bug here showed by diff (and a few other before)
> is therefore something like this:
> New essential package A replaces old essential package B.
> (Package B is now a transitional package to A.)
> The user (with mixed sources) tries to deinstall package B and
> apt refuses that as it thinks B is essential - it doesn't take into
> account that A provides the same functionality as B.
> 
> Could we agree on that it is a (very) minor bug?

Yes.

-- 
Vincent Lefèvre <[email-masked]> - Web: <http://www.vinc17.net/>
100% accessible validated (X)HTML - Blog: <http://www.vinc17.net/blog/>
Work: CR INRIA - computer arithmetic / Arénaire project (LIP, ENS-Lyon)